 #define Version "170327"
 //resolu PB carcatere en CGRAM
 // modif fonction    void LCD_Write_Chr_At(int Ligne,int col,char c1,int special);
 // drapeau "Special" =1 pour afficher caracteres cres adresse 0  15


// #define Version "170326"
// modif pour usage de 2 DS18B20 AVEC LCD 2119 I2C
// modif fichier Pic EEPROM , rajout ID des 2 sondes DS18B20
// les 2 sondes OWS sont sur l'entree RA1
//  #define Version "170325"
// modif pour usage de 1 DS18B20 SANS LCD I2C
// test sous 3,3V seulement
// voir PB caractere en CGRAM

#define POWER_SUPPLY "3.3V"    // (3,3 to 4,2V battery)
#define Source "_16F1847_OWS_2xDS18B20_Temp_LCD_I2C"      // sans extension !

// #define Version "170130"
#define Langage "MikroC 7.0.1"
#define Directory "C:\\_MikroC\\_MesProjets_MikroC\\_16F1847_OWS_DS18B20"
#define Projet "16F1847_OWS_18B20_temper_2017.mcppi"
//#define Source "_16F1847_OWS_1xDS18B20_Temper"      // sans extension !
#define MCU "16F1847 DIP18"
//#define POWER_SUPPLY "5V"    // (3,3 to 4,2V battery)
#define OSCILLATEUR_INTERNE
#define EEPROM_FILE "16F1847_OWS_2x18B20_temper_2017_eeprom.ihex"

#ifdef OSCILLATEUR_INTERNE
#define FOSC "Interne 8MHz"
//  FOSC interne 8 MHz
//  P16F1847_Fosc_interne_8MHZ.cfgsch
//CONFIG1 : $8007 : 0x39E4
//CONFIG2 : $8008 : 0x1613
#else
#define FOSC " Q=8MHz"
//P16F1847_Q8MHZ.cfgsch
//CONFIG1 : $8007 : 0x39E2
//CONFIG2 : $8008 : 0x1613
#endif

#define With_LCD_I2C
#define With_UART
//#define Test_UART

 //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define BELL 7

 //    ac:Pinout_16F1847
 
  //
 

/// Hardware 16F1847  DIP18 :
/*
 -Alim 3.3v
PIN 1    RA2/AN2 or DACOUT
PIN 2    RA3 AN3   libre
PIN 3    RA4/AN4
                    |---750--ICSP VPP  PIN 1 Pickit2
Pin 4     RA5/ MCLR |--- 6,8K --- +3,3V
Pin 5     VSS et ------------ICSP Gnd Pin 3  Pickit2
pin 6     RB0
pin 7     RB1 Alternate to  SDA1------I2C bus  ----2,7K --+5V
pin 8     RB2 RX UART  <--- vert  <-- TX  Prolic 23023 PC COM
pin 9     RB3/AN9/ CCP1/P1A
-----
Pin 18    RA1   OWS 2x capteurs DS18B20 temperature
Pin 17    RA0   libre   (was EA0)
Pin 16    RA7 -
Pin 15    RA6
pin 14    VDD -----------------+5V
pin 13    RB7/AN6--- 750 --- ICSPDAT   Pin 4   Pickit2
pin 12    RB6/AN5--- 750 --- ICSPCLCK  Pin 5   Pickit2
pin 11    RB5/AN5   Alternate to TX UART    ---> blanc  --> RX  Prolic 23023 PC COM
pin 10    RB4 SCL1 ----------I2C BUS ---2,7K --- +3,3V
  */
  
#include "built_in.h"     // for  Hi  Lo ..etc
 
#ifdef With_LCD_I2C
// **********  Config Hardware **********************
#define LCD_ADR 0x74     // LCD2119 2 lignes de 16 cars
#define NbCarPL 16
#define  I2Cx_Wr   I2C1_Wr
#define  I2Cx_Start  I2C1_Start
#define  I2Cx_Repeated_Start  I2C1_Repeated_Start
#define I2Cx_Stop I2C1_Stop
#endif

// specific au capteur OWS DS18B20
#define THERM_CMD_CONVERTTEMP   0x44
#define THERM_CMD_RSCRATCHPAD   0xBE
#define THERM_CMD_WSCRATCHPAD   0x4E
#define THERM_CMD_CPYSCRATCHPAD 0x48
#define THERM_CMD_RECEEPROM     0xB8
#define THERM_CMD_RPWRSUPPLY    0xB4
#define THERM_CMD_SEARCHROM     0xF0
#define THERM_CMD_READROM       0x33
#define THERM_CMD_MATCHROM      0x55
#define THERM_CMD_SKIPROM       0xCC
#define THERM_CMD_ALARMSEARCH   0xEC

#include "../common/Delays.h"

const code char mesg0[]="                    "; // 20 blancs pour effacer la ligne LCD
const code char mesg1[]=" Compilateur : "Langage"\n\r";
const code char mesg2[]=" Directory :"Directory"\r\n";
const code char mesg3[]=" Projet    :"Projet"\r\n";
const code char mesg4[]=" Source    :"Source"_"Version".c\r\n";
const code char * Messages[]={mesg0,mesg1,mesg2,mesg3,mesg4};

char TEXTE[80];
char * txt;
char CRam1[64];
char *p;
unsigned int i,j,k,l,m;

#define MAXLEN1 80

// UART & Texte variables
unsigned char buffer1[MAXLEN1];
unsigned int Index1=0;
unsigned int UART1_DataReady=0;
unsigned int i1=0;
unsigned char c1;
int CptErr;

unsigned int Cpt1;   // timer1 overflow count
int Etat;
int addr;

//  Set TEMP_RESOLUTION to the corresponding resolution of used DS18x20 sensor:
//  18S20: 9  (default setting; can be 9,10,11,or 12)
//  18B20: 12
const unsigned short TEMP_RESOLUTION = 12;
char *Temper = "000.0000";
unsigned int temp;


/* Adresses des capteurs de temprature */
unsigned char  SENSOR_ADDRESS[2][8]=
{
 { 0, 0, 0, 0, 0, 0, 0, 0 }, // Data: FamilyCode 28 ID2= FF4715811603 CRC= 24
 { 0, 0, 0, 0, 0, 0, 0, 0 }  // Data: FamilyCode 28 ID1= FF83C7641503 CRC= B8
};


// choix sensor 1 ou 2
unsigned char Valid_Sensor;
char Degres;
char Signe;

unsigned long  DS18B20_Temp1;
unsigned int temp_fraction;
char TH1=19;
char TL1=15;

unsigned long  DS18B20_Temp2;
char TH2=20;
char TL2=14;
char c2;

 #ifdef With_LCD_I2C
 unsigned char Buff_LCD[17];
 #endif

void Read_Msg_Eeprom(unsigned char depuis);
void Init_Hardware(void);
void Init_Timer1(void);
void Float2Ascii (float x, unsigned char *str,char precision);
void strConstRamCpy(char *dest, const char *source);
void Special_Init_UART_RB2_RB5(void);
void RAZ_UART1(void);
void UART1_Write_CText(const char *txt1);
void CRLF1(void);

char Convert_Temperature(unsigned int temp2write);
void Adresse_Device_DS18B20(int N);
void Lecture_ID_Sensor(int NS);
// void Update_Thresholds(int numX);

 #ifdef With_LCD_I2C
 // LCD 2119 2x16 cars     en I2 hardware
void LCD_CLS(void);
int LCD2119_Init(void);
void LCD_RAZ_Ligne(int L);
void LCD_Write_Chr_At(int Ligne,int col,char c1,int special);
void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1);
void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1);
void LCD_Write_CText(const char * t1);
void Cree_Euro(void) ;
void Cree_8_cars_CGRAM(void)  ;
void LCD_Cde(unsigned char Cde);
void LCD_Gauche(void);
void LCD_Droite(void);
#endif

void Interrupts() iv 0x0004 ics ICS_AUTO 
{
  if ( (RCIE_bit) && ( PIR1.RCIF))
   {
    //  TXREG='@';
   // traitement separe des erreurs de COM
      if (RCSTA.OERR==1)    // voir parag 16.1.26 p273
      {
       RCSTA.CREN = 0 ;
       c1 = RCREG;
       RCSTA.CREN = 1 ;
       CptErr++;
       }
      if(RCSTA.FERR==1 )
      {
      RCSTA.SPEN = 0 ;
      RCSTA.SPEN= 1 ;
      CptErr++;
       c1 = RCREG;
      }
      c1 = RCREG;
     if (c1==CR)
      {
      UART1_DataReady=1;
      PIE1.RCIE=0 ; //interdit IT Reception UART
      buffer1[i1]=0;
      Index1=i1;
      i1=0;
      c1=0;
     }
     else
     {
        buffer1[i1]=c1;
        Index1=i1;
        i1++;
        if (i1>=MAXLEN1) i1=0;
      }
   }
}


char Convert_Temperature(unsigned int temp2write)
{
  const unsigned int RES_SHIFT = TEMP_RESOLUTION - 8;
  char i;
  char temp_whole;
  DS18B20_Temp1=0;
  // Check if temperature is negative
  if (temp2write & 0x8000) {
     Signe=1;
     temp2write = ~temp2write + 1;  // complement  2
     }
     else
     Signe=0;
  // Extract temp_whole
  temp_whole = temp2write >> RES_SHIFT ;
  if (Signe==1) temp_whole= -temp_whole;
  DS18B20_Temp1= ( long)temp_whole;
  // Extract temp_fraction and convert it to unsigned int
  temp_fraction  = temp2write << (4-RES_SHIFT);
  temp_fraction &= 0x000F;
  temp_fraction *= 625;
  DS18B20_Temp1= DS18B20_Temp1 *10000 + (unsigned long)temp_fraction;
  return(temp_whole);
}

void Adresse_Device_DS18B20(int N)
{
 int i;
    Ow_Reset(&PORTA, 1);       // Onewire reset signal
     //The match ROM command followed by a 64-bit ROM code sequence allows
     //the bus master to address a specific slave device on a multidrop or single-drop bus.
     // Only the slave that exactly matches the 64-bit ROM code sequence will respond to
     // the function command issued by the master
     Delay_us(250);
     Ow_Write(&PORTA, 1, THERM_CMD_MATCHROM ); //0x55
      for (i=0;i<8;i++)
      {
         Ow_Write(&PORTA, 1, SENSOR_ADDRESS[N-1][i])  ;
         Delay_us(250);
       }
        Delay_us(250);
   }


void Update_Thresholds(int numX)
{
    int i;

     Adresse_Device_DS18B20(numX);

     Ow_Write(&PORTA, 1, THERM_CMD_WSCRATCHPAD); // Write Scratchpad [4Eh] command
     Delay_us(750);
     switch(numX)
     {
       case 1:
       {
            Ow_Write(&PORTA, 1, TH1);  //Byte 2  TH Register or User Byte 1*
            Delay_us(750);
            Ow_Write(&PORTA, 1, TL1);  //Byte 3  TL Register or User Byte 2*
            break;
       }
       case 2:
        {
           Ow_Write(&PORTA, 1, TH2);  //Byte 2  TH Register or User Byte 1*
           Delay_us(750);
           Ow_Write(&PORTA, 1, TL2);  //Byte 3  TL Register or User Byte 2*
           break;
        }
      }
     Delay_us(750);
     Ow_Write(&PORTA, 1, 0x7F);  //config 12 bits  Byte *3
     Delay_us(750);
     Adresse_Device_DS18B20(numX);
     Delay_us(750);
     Ow_Write(&PORTA, 1, THERM_CMD_CPYSCRATCHPAD); // 0x48 transfert store to EEPROM
     UART1_Write_CText(" ->stored in DS18B20\r\n");
     CRLF1();
}


void Lecture_ID_Sensor(int NS)
{    unsigned int AC;  // Adresse courante eeprom
     int i;
     unsigned char cx;
     UART1_Write_CText("\r\n1 seul DS18B20 doit etre connect\r\n");
     Ow_Reset(&PORTA, 1);       // Onewire reset signal
     Ow_Write(&PORTA, 1, THERM_CMD_READROM); // 0x33 Read ROM (if only one device)
     Delay_us(750);
     cx=Ow_Read(&PORTA, 1); // 123456789012345678901234567890123456789012345678
     strConstRamCpy(txt ,    "Data: FamilyCode .. ID.= xxxxxxxxxxxx CRC= ..");
     *(txt+22)=NS+48;
     //64-Bit Lasered ROM Code
    // 8-BIT CRC      48-BIT SERIAL NUMBER     8-BIT FAMILY CODE (28h)
    // LSB=family code: 28h.
    //The next 48 bits contain a unique serial number.
    // MSB contains CRC 8 bits
     ByteToHex(cx,CRam1);
     AC=0x00A0 + NS*16 ;
    // IDx[0]=c1;
     EEPROM_Write(AC,cx);
     SENSOR_ADDRESS[NS-1][0]=cx;
     Delay_ms(5);        // was 25
     memcpy(txt+17,CRam1,2);
     for (i=1;i<7;i++)
     {
     cx=  Ow_Read(&PORTA, 1);
     //IDx[i]=cx;
     EEPROM_Write(AC+i,cx);
     SENSOR_ADDRESS[NS-1][i]=cx;
     Delay_ms(5);    // was 25
     ByteToHex(cx,CRam1);
     memcpy(txt+23+i*2,CRam1,2);
     }
     cx=  Ow_Read(&PORTA, 1); // CRC
     EEPROM_Write(AC+i,cx);
     SENSOR_ADDRESS[NS-1][7]=cx;
     ByteToHex(cx,CRam1);
     //IDx[7]=c1;
     memcpy(txt+43,CRam1,2);
     UART1_Write_Text(txt);
     CRLF1() ;
     Delay_ms(25); // was 750
     Valid_Sensor=Valid_Sensor | NS;
}
//************************************************

void RAZ_UART1()
{      int i1;
      for (i1=0;i1<MAXLEN1;i1++) buffer1[i1]=0;
      Index1=0;
      i1=0;
      c1=RCREG;  // vide le buffer RCREG
      c1=0;
      UART1_DataReady=0;
     // REGISTER 8-2: PIE1: PERIPHERAL INTERRUPT ENABLE REGISTER 1
      PIE1.RCIE=1 ;
}

void UART1_Write_CText(const char *txt1)
 {
   while (*txt1)
      UART1_Write(*(txt1++));
}

// --- Copie le texte depuis ROM vers RAM
void strConstRamCpy(char *dest, const char *source)
 {
  while(*source) *(dest++) = *(source++) ;
  *dest = 0 ;    // terminateur
}

void CRLF1()
{
 UART1_Write(CR);
  UART1_Write(LF);
 }

void Read_Msg_Eeprom(unsigned char debut)
{   int i1 ;
unsigned char c;
  i1=debut;
  do
  {
  c = EEPROM_Read(i1);
  if ( c==0) break;
  if ( i1>254) break;
  UART1_Write(c);
  Delay_ms(5);
  i1++;
   }
  while (c!=0) ;
 }

void Init_Hardware()
{
  TRISB  = 0xFF;
  TRISA  = 0xFF;
  PORTA=0;
  //ANSELA = 0b00000001;  //  RA0 as analog
  ANSELA = 0b00000000;  // NO analog
 //
  ANSELB = 0;           // PORTB en Digital
 // If Configuration Word 1 , MCLR is enabled Weak Pull-up is always enabled.
  WPUA5_bit=1;
  WPUB=0;  // no pullup
  //Global WPUEN bit of the OPTION_REG register must be cleared for individual pull-ups to be enabled
  TRISB.B1 = 1;  // SDA1 I2C
  TRISB.B4 = 0;  // SCL1 I2C
  TRISB.B5 = 0;  // TX UART
  TRISB.B2 = 1;  // RX UART
  TRISB.B6 = 1;  // Timer1 input

  CM1CON0=0;       // disable comparators 1
  CM1CON1=0;
  CM2CON0=0;       // disable comparators  2
  CM2CON1=0;
}

void Special_Init_UART1_RB2_RB5(void)
{
  //DS41453B-page 120
 /* bit 7 RXDTSEL: Pin Selection bit
  0 = RX/DT function is on RB1
  1 = RX/DT function is on RB2
  bit 6 SDO1SEL: Pin Selection bit
  0 = SDO1 function is on RB2
  1 = SDO1 function is on RA6
  bit 5 SS1SEL: Pin Selection bit
      0 = SS1 function is on RB5
      1 = SS1 function is on RA5
      */

  APFCON0.SDO1SEL=1; //0 = SDO1 function is on RB2 , 1 = SDO1 function is on RA6
  APFCON0.SS1SEL=1;  // 1 = SS1 function is on RA5
  APFCON0.RXDTSEL=1; // 1 = RX/DT function is on RB2
  APFCON1.TXCKSEL=1;     // RB5 as TX UART
  BAUDCON.WUE=0;  //Wake-up Enable bit  0 = Receiver is operating normally
  CPSCON0 = 0 ;//CAPACTIVE SENSE MODULE OFF
  TRISB.B2=1;
 }


void Init_Timer1(void)
{
 //REGISTER 21-1: T1CON: TIMER1 CONTROL REGISTER   DS41453B-page 187
 // TMR1CS<1:0> T1CKPS<1:0> T1OSCEN T1SYNC  TMR1ON
 T1CON=0;
 //TMR1CS<1:0>: Timer1 Clock Source Select bits
 //TABLE 21-2: CLOCK SOURCE SELECTIONS
 //TMR1CS1 TMR1CS0 T1OSCEN   Clock Source
 // 1        0        0     External Clocking on T1CKI Pin
 //  10 =Timer1 clock source is pin or oscillator:
 // If T1OSCEN = 0:  External clock from T1CKI pin (on the rising edge)
 TMR1CS1_bit=1;
 TMR1CS0_bit=0;
 //T1CKPS<1:0>: Timer1 Input Clock Prescale Select bits
 //00 = 1:1 Prescale value
 T1CKPS1_bit=0;
 T1CKPS0_bit=0 ;
 T1OSCEN_bit=0;
 T1CON.B2=1; // T1SYNC=1  1 = Do not synchronize external clock input;
 // TMR1ON TMR1GE Timer1 Operation
// 0        0            Off
// 0        1            Off
// 1        0            Always On
 TMR1ON_bit=1;
 //REGISTER 21-2: T1GCON: TIMER1 GATE CONTROL REGISTER
//  TMR1GE T1GPOL T1GTM T1GSPM T1GGO/DONE   T1GVAL T1GSS<1:0>
  TMR1GE_bit=0;   //Timer1 Gate Enable bit Timer1 counting is controlled by the Timer1 gate function
  T1GPOL_bit=0;  // T1GPOL: Timer1 Gate Polarity bit   1 = Timer1 counts when gate is high)
  T1GTM_bit=0;         //Timer1 gate flip-flop toggles on every rising edge.
  T1GSPM_bit=0; // Timer1 Gate Single-Pulse Mode bit disabled
 // Timer1 gate Source  T1GSS<1:0>: Timer1 Gate Source Select bits 00 Timer1 Gate Pin
 T1GSS1_bit=0;
 T1GSS0_bit=0;
 Cpt1=0;
 //10 = Comparator 1 optionally synchronized output (SYNCC1OUT)
}


void Float2Ascii (float x, unsigned char *str,char precision)
{
 /* converts a floating point number to an ascii string */
 /* x is stored into str, which should be at least 30 chars long */
 unsigned char *adpt;
 int ie, i, k, ndig;
 double y;
 ndig = ( precision<=0) ? 7 : (precision > 22 ? 23 : precision+1);
 ie = 0;
 /* if x negative, write minus and reverse */
 if ( x < 0)
 {
   *str++ = '-';
   x = -x;
 }
 /* put x in range 1 <= x < 10 */
 if (x > 0.0) while (x < 1.0)
 {
   x *= 10.0;                // a la place de =*
   ie--;
 }
 while (x >= 10.0)
 {
   x = x/10.0;
   ie++;
 }
 // in f format, number of digits is related to size
 ndig += ie;                                // a la place de =+
 //round. x is between 1 and 10 and ndig will be printed to
 // right of decimal point so rounding is ...
 for (y = i = 1; i < ndig; i++)
 y = y/10.;
 x += y/2.;
 if (x >= 10.0) {x = 1.0; ie++;}
 if (ie<0)
 {
   *str++ = '0'; *str++ = '.';
   if (ndig < 0) ie = ie-ndig;
   for (i = -1; i > ie; i--)  *str++ = '0';
 }
 for (i=0; i < ndig; i++)
 {
   k = x;
   *str++ = k + '0';
   if (i ==  ie ) *str++ = '.';
   x -= (y=k);
   x *= 10.0;
  }
 *str = '\0';
}

#ifdef With_LCD_I2C
// *** LCD 2119 ***********
void LCD_CLS()
{
// d'abord la ligne 2 pour avoir le curseur en 0 de ligne 1
LCD_RAZ_Ligne(2);
LCD_RAZ_Ligne(1);
}

int LCD2119_Init(void)
{
// see datasheet PCF2119x NXP Semiconductorspage 69
int j,k;
k=0;
Delay_ms(500);
I2Cx_Start();
j=I2Cx_Wr(LCD_ADR); // i2c slave Address
if (j!=0) return k;
k++;
Delay_ms(200);
j=I2Cx_Wr(0x00);    // Control byte for Instruction
if (j>0) return k;
k++;
I2Cx_Wr(0x24); //0x20 +  DL=0 format 4 ou 8 bits not used, M=1 car 2x16 cars display, SL=0 1:18, H: mode standard
I2Cx_Wr(0x0C); // D: Display on, C: curser off, B: blink off
I2Cx_Wr(0x06); // Entry mode set : I/D: increment, S: no shift
I2Cx_Wr(0x25); // DL: 8 bits, M: 16 by two line, SL: 1:18, H: extended instruction set
//I2Cx_Wr(0x04); // P: left to right, Q: top to bottom    sur connecteur A
I2Cx_Wr(0x06); // P: Right to left ,Q: top to bottom      sur connecteur B
I2Cx_Wr(0x11); // TC1: 0, TC0: 1
I2Cx_Wr(0x42); // HV Stages 3
//I2Cx_Wr(0x9f); // set Vlcd, store to VA
I2Cx_Wr(0x96); // set Vlcd, store to VA  (avec alim=3,3V)
j=I2Cx_Wr(0x24); // DL: 8 bits, M: two line, SL: 1:18, H: normal instruction set
if (j>0) return k;
k++;
j=I2Cx_Wr(0x0C);
if (j>0) return k;
k++;
j=I2Cx_Wr(0x06);
if (j>0) return k;
k++;
j=I2Cx_Wr(0x02); // return home
if (j>0) return k;
k++;
// avec LC2119 RU  remplissage avec caractere >> au lieu de blanc=espace
/// il faut un modele LCD2119 AU  !
j=I2Cx_Wr(0x01); // clear display
if (j>0) return k;
Delay_ms(100);
I2Cx_Stop();
k++;
return k;
}

void LCD_RAZ_Ligne( int L)
{
int i;
 I2Cx_Start();
 I2Cx_Wr(LCD_ADR); // i2c slave Address
 I2Cx_Wr(0x00); // Control byte for Instruction
 I2Cx_Wr(0x02); // return home
 switch (L)
 {
  case 1:
      I2Cx_Wr(0x80); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2Cx_Wr(0xC0); // DDRAM Address 2em ligne
      break;
  default:
  break ;
 }
 I2Cx_Repeated_Start();
 I2Cx_Wr(LCD_ADR); // i2c slave Adress
 I2Cx_Wr(0x40);     // Control byte for Data
 for (i=0;i<NbCarPL;i++)   // was 39 !
 {
   I2Cx_Wr(0x80+32); //  0x80+32 =0xA0 efface avec des blanc
 }
 // repositionne au debut de ligne
 I2Cx_Repeated_Start();
 I2Cx_Wr(LCD_ADR); // i2c slave Adress
 I2Cx_Wr(0x00); // Control byte for Instruction
 //I2Cx_Wr(0x40);     // Control byte for Data
 switch (L)
  {
   case 1:
         I2Cx_Wr(0x80); // DDRAM Address 1ere ligne
        break;
   case 2:
        I2Cx_Wr(0xC0); // DDRAM Address 2em ligne
        break;
   default:
        break ;
  }
 I2Cx_Stop();
}

void LCD_Write_CText(const char * t1)
 {
  char TT[21];
  int i;
  strConstRamCpy(TT,t1);
  I2Cx_Start();
  I2Cx_Wr(LCD_ADR); // i2c slave Address
  I2Cx_Wr(0x00); // Control byte for Instruction
 I2Cx_Repeated_Start();
 I2Cx_Wr(LCD_ADR); // i2c slave Adress
 I2Cx_Wr(0x40); // Control byte for Data
 i=0;
 while(*(t1))
 {
  I2Cx_Wr(0x80+*(t1));
  t1++;
  i++;
 // if (i>NbCarPL) break;
 }
 I2Cx_Stop();
}

void LCD_Write_CText_At(unsigned int Ligne,unsigned int col,const char * t1)
 {
  char TT[21];
  int i;
  strConstRamCpy(TT,t1);
  I2Cx_Start();
  I2Cx_Wr(LCD_ADR); // i2c slave Address
  I2Cx_Wr(0x00); // Control byte for Instruction
  if(col>NbCarPL) col=NbCarPL;
  switch (Ligne)
 {
  case 1:
      I2Cx_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2Cx_Wr(0xc0+col-1); // DDRAM Address 2em ligne
        break;
  default:
  break ;
 }
 I2Cx_Repeated_Start();
 I2Cx_Wr(LCD_ADR); // i2c slave Adress
 I2Cx_Wr(0x40); // Control byte for Data
 i=col;
 while(*(t1))
 {
  I2Cx_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>NbCarPL) break;
 }
 I2Cx_Stop();
}

void LCD_Write_Chr_At(int Ligne,int col,char c1,int Special)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  // .. Special =0 pour ascii normal   1 pour caracteres perso definis en CGRAM
  I2Cx_Start() ;
  I2Cx_Wr(LCD_ADR); // i2c slave Adress
  I2Cx_Wr(0x00); // Control byte for Instruction
  if(col>NbCarPL) col= NbCarPL;
  switch (Ligne)
  {
  case 1:
      I2Cx_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2Cx_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2Cx_Repeated_Start() ;
  I2Cx_Wr(LCD_ADR); // i2c slave Address
  I2Cx_Wr(0x40); // Control byte for Data
  if (Special==1)  I2Cx_Wr(c1);  else  I2Cx_Wr(0x80+c1);  // bug corrig 27-03_2017
  I2Cx_Stop();
 }

void LCD_Write_Text_At(unsigned int Ligne,unsigned int col,char * t1)
{ //.. ligne 1 ou 2
  //.. col de 1  16
  int i;
  I2Cx_Start();
  I2Cx_Wr(LCD_ADR); // i2c slave Address
  I2Cx_Wr(0x00); // Control byte for Instruction
  if(col>NbCarPL) col=NbCarPL;
  switch (Ligne)
  {
  case 1:
      I2Cx_Wr(0x80+col-1); // DDRAM Address 1ere ligne
      break;
  case 2:
      I2Cx_Wr(0xc0+col-1); // DDRAM Address 2em ligne
      break;
  default:
      break ;
  }
  I2Cx_Repeated_Start();
  I2Cx_Wr(LCD_ADR); // i2c slave Adress
  I2Cx_Wr(0x40); // Control byte for Data
  i=col;
  while(*(t1))
  {
  I2Cx_Wr(0x80+*(t1));
  t1++;
  i++;
  if (i>NbCarPL) break;
  }
  I2Cx_Stop();
}

void LCD_Home()
{
 LCD_Cde(0x02);
}

void LCD_Cde(unsigned char Cde)
{
 I2Cx_Start();
 I2Cx_Wr(0x76); //Display adress
 I2Cx_Wr(0x00); //Register Select Config Register
 I2Cx_Wr(Cde); //Write Data
 I2Cx_Stop();
}


void check_device(unsigned char dev_address)
{
strConstRamCpy(txt,"Device at adresse : ");
k=strlen(txt);
ByteToStr(dev_address,CRam1);
strcat(txt+k,CRam1);
UART1_Write_Text(txt);
I2Cx_Start();
if(I2Cx_Wr(dev_address)!=0 )
 {
  UART1_Write_CText(" is not found");
 }
 else
 {
  UART1_Write_CText(" found OK");
  }
I2Cx_Stop();
 CRLF1();
}

void Decompile_byte(unsigned char un)
{
 unsigned char masque;
 masque = 0x80;
 while (masque > 0u )
 {
   if ((un & masque)>0)
       UART1_Write(49u);  //  '1'
    else
       UART1_Write(48u);  //  '0'
    masque =masque >>1;
  }
}


void Cree_8_cars_CGRAM()
{
unsigned char b1,b2;
 I2C1_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x00);
 // Cde Set_CGRAM address to 0  =>  (0x40 + adresse=0 )
 I2C1_Wr(0x40);
// I2C1_Start();
 I2C1_Repeated_Start() ;
 I2C1_Wr(LCD_ADR); // i2c slave Adress
 I2C1_Wr(0x40);// set CGRAM adress
 //Probleme : 5 pixels seulement accessibles en largeur (sur 8)
// blanc
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
  b2=32;
  b1=0;
  for (i=0;i<5;i++)
  {
   b2=b2>>1;
   b1=b1+b2;
   for (j=0;j<8;j++)
   {
   #ifdef With_UART
     UART1_Write_CText("I2C1_Wr(");
     Decompile_byte(b1);
     CRLF1();
     #endif
     I2C1_Wr(b1);

   }
   #ifdef With_UART
    CRLF1();
    #endif
  }

// degre C
I2Cx_Wr(0b00000000);
I2Cx_Wr(0b00001110);
I2Cx_Wr(0b00010001);
I2Cx_Wr(0b00001110);
I2Cx_Wr(0b00000000);
I2Cx_Wr(0b00000000);
I2Cx_Wr(0b00000000);
I2Cx_Wr(0b00000000);

// The Euro currency character can be recognized by the 0/1 pattern (see Figure 48)
I2C1_Wr(0x06); // 00110
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x1E); // 11110
I2C1_Wr(0x08); // 01000
I2C1_Wr(0x09); // 01001
I2C1_Wr(0x06); // 00110
  // petit rectangle
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0011111);
I2C1_Wr(0b0010001);
I2C1_Wr(0b0011111);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Wr(0b0000000);
I2C1_Stop();
}

/*

void Cree_Degre_C()
{
// Write a user defined character into the CGRAM
 I2C1_Start();
 I2C1_Wr(LCD_ADR); // i2c slave Adress

// MSB (Continuation bit Co) = 0, more than one byte may follow. Bit6, RS=0, next byte
// is command byte
  I2Cx_Wr(0x00);
// 2 lines x 16, 1/18 duty, basic instruction set. Next byte will be another command.
  I2Cx_Wr(0x24);
// Set CGRAM address to 0
  I2Cx_Wr(0x40);
   I2C1_Repeated_Start() ;
//  I2Cx_Stop();
// Repeated Start condition
// I2Cx_Start();
 I2Cx_Wr(LCD_ADR); // i2c slave Adress;
// RS=1, next byte is a data byte
  I2Cx_Wr(0x40);
// Here the data bytes to define the character
// Behind the write commands the 5x8 dot matrix is shown, the 1 represents a on pixel.
// The Euro currency character can be recognized by the 0/1 pattern (see Figure 48)
I2Cx_Wr(0b00000000);
I2Cx_Wr(0b00011110);
I2Cx_Wr(0b00010010);
I2Cx_Wr(0b00011110);
I2Cx_Wr(0b00000000);
I2Cx_Wr(0b00000000);
I2Cx_Wr(0b00000000);
I2Cx_Wr(0b00000000);
I2Cx_Stop();
}
 */

#endif


void main()
 {
  // Internal FOSC is 500Khz by default !
  #ifdef OSCILLATEUR_INTERNE
  OSCCON =0;        // PLL disbled
  OSCCON.IRCF3=1;         //8 MHz
  OSCCON.IRCF2=1;
  OSCCON.IRCF1=1;
  OSCCON.IRCF0=0;
  OSCCON.SCS1=1;  // internal FOSC
  #endif

  Init_Hardware() ;
  
 // Test zone

  
  Delay_ms(1000);

  txt=TEXTE; // init pointeur
  UART1_Init(19200); // Hardware UART init won't work with RB2 as RX  , and  RB5 as TX is OK
  Delay_ms(100);
  // ecraser la config UART precedente..  faire Apres, sinon RX RB2 mal configur
  Special_Init_UART1_RB2_RB5();
  Delay_ms(100);
  while(PIR1.RCIF==1) c1 = RCREG;
  UART1_Write(CLS);
  Delay_ms(500);
  UART1_Write_CText("\r\n Init Speciale UART: Rx RB2 et TX RB5\r\n");
  for (i=1;i<4;i++)  UART1_Write_CText(Messages[i]);
  CRLF1();
  Read_Msg_Eeprom(0);
  Read_Msg_Eeprom(0x40);
  Read_Msg_Eeprom(0xE0);
  CRLF1();  CRLF1();
  
  
   UART1_Write_CText("ID #1 ");
   c1=EEPROM_Read(0xB0);   // 0x28 pour DS18B20
   if (c1!=0x28) UART1_Write_CText("?\r\n");
   else
   {
    for (i=0;i<8;i++)
    {
      c1=EEPROM_Read(0xB0+i);
      SENSOR_ADDRESS[0][i] =c1;
      ByteToHex(c1,CRam1) ;
      UART1_Write_Text(CRam1);UART1_Write(' ');
    }
   CRLF1();
   Valid_Sensor.B0=1;
   }

   c1=EEPROM_Read(0xC0);
   UART1_Write_CText("ID #2 ");
   if (c1!=0x28) UART1_Write_CText("?\r\n");
   else
   {
     for (i=0;i<8;i++)
     {
      c1=EEPROM_Read(0xC0+i);
      SENSOR_ADDRESS[1][i] =c1;
      ByteToHex(c1,CRam1);
      UART1_Write_Text( CRam1);UART1_Write(' ');
      }
   CRLF1();
   Valid_Sensor.B1=1;
   }
   txt=&TEXTE[0];
  

   RAZ_UART1();
   PIE1.RCIE=1; // Enables the USART receive interrupt
   PEIE_bit=1; // INTCON  Enables all active peripheral interrupts
   GIE_bit=1;  // INTCON   Global Interrupt Enable bit

  
   #ifdef With_LCD_I2C
   I2C1_Init(400000);

  // adrr= adresse LCD
   CRLF1();
   addr=LCD_ADR;
   check_device(addr);
   UART1_Write_CText(" Init Display LCD2119\r\n");
   k=0;
   k= LCD2119_Init();
   LCD_CLS();
   WordToStr(k,txt);
   UART1_Write_CText(" Nb Step = "); // 7 steps=OK
   UART1_Write_Text(txt); UART1_Write_CText(" sur 7\r\n");
   CRLF1();
   if (k==7)  LCD_Write_CText_At(1,1,"Init LCD en 7pas");
   Delay_ms(2000);

  LCD_Write_CText_At(1,1,"Version : "Version);
  LCD_Write_CText_At(2,1,"Mesure de Temper.");
  Delay_ms(4000);
  LCD_CLS();
  LCD_Write_CText_At(1,1,"2 Sensor DS18B20");
  LCD_Write_CText_At(2,1,"Temperature Amb.");
  Delay_ms(4000);
  
   Cree_8_cars_CGRAM();
   // dont le caractere Degre_C();
   LCD_CLS();
    LCD_Write_CText_At(1,1,"Affi.8 car CGRAM");
    for (i=0;i<8;i++)
     {
       LCD_Write_Chr_At(2,i+1,i,1);
     }
   LCD_Write_Chr_At(2,10,0,1);
   Delay_ms(5000);
   #endif
    
  CRLF1();
  RAZ_UART1();

    PIE1.RCIE=1; // Enables the USART receive interrupt
   PEIE_bit=1; // INTCON  Enables all active peripheral interrupts
   GIE_bit=1;  // INTCON   Global Interrupt Enable bit

   j=0;
  //--- Main loop
  do {
         txt=&TEXTE[0];     //  12345678901234567890123456789
          strConstRamCpy(txt , "j=255;T1=+100.00;T2=+100.00;\r");
          ByteToStr((unsigned char)j,CRam1);
          memcpy(txt+2,CRam1,3);
          if (Valid_Sensor.B0==1)
          {
        // mesure sonde #1
          Adresse_Device_DS18B20(1);
          Ow_Write(&PORTA, 1,THERM_CMD_CONVERTTEMP  ); // 0x44
          Delay_ms(10);
          Adresse_Device_DS18B20(1);
          Delay_ms(10);
          Ow_Write(&PORTA, 1,THERM_CMD_RSCRATCHPAD); // 0xBE  Issue command READ_SCRATCHPAD
          //Byte 0 and byte 1 of the scratchpad contain the LSB and the MSB of the temperature register
          temp =  Ow_Read(&PORTA, 1);
          temp = (Ow_Read(&PORTA, 1) << 8) + temp;
           //  Bytes 2 and 3 provide access to TH and TL registers
          TH1=  Ow_Read(&PORTA, 1);
          TL1=  Ow_Read(&PORTA, 1);
                                   // 1234567890123456
          strConstRamCpy(Buff_LCD , "Tamb1= *000.00C");

          //--- Format and display result
          Degres=Convert_Temperature(temp);
          ByteToStr(Degres,CRam1) ;
          memcpy(Buff_LCD+8,CRam1,3);
          if (Signe==1) 
          {
             *(txt+9)='-';
             *(Buff_LCD+7)='-';
             }
             else
             {
               *(txt+9)=' ';
                *(Buff_LCD+7)=' ';
               }
          memcpy(txt+10,CRam1,3);
          WordToStrWithZeros (temp_fraction,CRam1);
          memcpy(txt+14,CRam1+1,2) ;
          memcpy(Buff_LCD+12,CRam1+1,2);
          *(Buff_LCD+14)=8;
                                //1234567890123456
          #ifdef With_LCD_I2C
           LCD_Write_Text_At(1,1,Buff_LCD);
            LCD_Write_Chr_At(1,15,6,1);
           
           #endif
          }

         if(Valid_Sensor.B1==1)
         {
       //mesure sonde #2
         Adresse_Device_DS18B20(2);
         Ow_Write(&PORTA, 1,THERM_CMD_CONVERTTEMP  ); // 0x44 Issue command CONVERT_T
         Delay_ms(10);
         Adresse_Device_DS18B20(2);
         Delay_ms(10);
         Ow_Write(&PORTA, 1,THERM_CMD_RSCRATCHPAD); // 0xBE  Issue command READ_SCRATCHPAD
         //Byte 0 and byte 1 of the scratchpad contain the LSB and the MSB of the temp register
         temp =  Ow_Read(&PORTA, 1);
         temp = (Ow_Read(&PORTA, 1) << 8) + temp;
          //  Bytes 2 and 3 provide access to TH and TL registers
         TH2=  Ow_Read(&PORTA, 1);
         TL2=  Ow_Read(&PORTA, 1);
         
          //--- Format and display result
                                   //1234567890123456
          strConstRamCpy(Buff_LCD , "TExt.= +000.00C");
          Degres=Convert_Temperature(temp);
          ByteToStr(Degres,CRam1)  ;
          memcpy(Buff_LCD+8,CRam1,3);
          if (Signe==1)
          {
             *(txt+20)='-';
             *(Buff_LCD+7)='-';
             }
             else
             {
               *(txt+20)=' ';
                *(Buff_LCD+7)=' ';
               }
               
          memcpy(txt+21,CRam1,3);
          WordToStrWithZeros (temp_fraction,CRam1);
          memcpy(txt+25,CRam1+1,2) ;
          memcpy(Buff_LCD+12,CRam1+1,2);

        
           #ifdef With_LCD_I2C
           LCD_Write_Text_At(2,1,Buff_LCD);
           LCD_Write_Chr_At(2,15,6,1);   // rajoute car special degre C
           #endif
          }
         UART1_Write_Text(txt); //"j=255;T1=- 19.06;T2=  22.43;\r\n") ;
         j++;
         j=j & 0x00FF;      //   255 maxi;

    Delay_ms(1000);
   
    }
  while(1);
 }
 
 /*

 Init Speciale UART: Rx RB2 et TX RB5
 Compilateur : MikroC 7.0.1
 Directory :C:\_MikroC\_MesProjets_MikroC\_16F1847_OWS_DS18B20
 Projet    :16F1847_OWS_18B20_temper_2017.mcppi

PIC16F1847 8MHZ
OWS 2 x DS18B20 sur RA1
Resolution 12 bits
ID number en EEPROM du PIC en 0xB0 et 0xC0
Version: 170325

ID #1 28 FF 47 15 81 16 03 24
ID #2 28 FF 83 C7 64 15 03 B8

Device at adresse : 116 found OK
 Init Display LCD2119
 Nb Step =     7 sur 7

I2C1_Wr(00010000
I2C1_Wr(00010000
I2C1_Wr(00010000
I2C1_Wr(00010000
I2C1_Wr(00010000
I2C1_Wr(00010000
I2C1_Wr(00010000
I2C1_Wr(00010000

I2C1_Wr(00011000
I2C1_Wr(00011000
I2C1_Wr(00011000
I2C1_Wr(00011000
I2C1_Wr(00011000
I2C1_Wr(00011000
I2C1_Wr(00011000
I2C1_Wr(00011000

I2C1_Wr(00011100
I2C1_Wr(00011100
I2C1_Wr(00011100
I2C1_Wr(00011100
I2C1_Wr(00011100
I2C1_Wr(00011100
I2C1_Wr(00011100
I2C1_Wr(00011100

I2C1_Wr(00011110
I2C1_Wr(00011110
I2C1_Wr(00011110
I2C1_Wr(00011110
I2C1_Wr(00011110
I2C1_Wr(00011110
I2C1_Wr(00011110
I2C1_Wr(00011110

I2C1_Wr(00011111
I2C1_Wr(00011111
I2C1_Wr(00011111
I2C1_Wr(00011111
I2C1_Wr(00011111
I2C1_Wr(00011111
I2C1_Wr(00011111
I2C1_Wr(00011111


j=  0;T1=  19.75;T2=  20.06;
j=  1;T1=  19.68;T2=  20.06;
j=  2;T1=  19.68;T2=  20.06;
j=  3;T1=  19.68;T2=  20.06;



0 1 mikroCPIC1618.exe -MSF -DBG -pP16F1847 -RA -C -O11111000 -fo8 -N"
C:\_MikroC\_MesProjets_MikroC\_16F1847_OWS_DS18B20\16F1847_OWS_2x18B20_temper_2017.mcppi" -EH"
C:\_MikroC\_MesProjets_MikroC\_16F1847_OWS_DS18B20\16F1847_OWS_2x18B20_temper_2017_eeprom.ihex" -SP"
C:\_MikroC\mikroC PRO for PIC\Defs\" -SP"
C:\_MikroC\mikroC PRO for PIC\Uses\P16_Enh\" -SP"
C:\_MikroC\_MesProjets_MikroC\_16F1847_OWS_DS18B20\" -SP"
C:\_MikroC\_MesProjets_MikroC\_FingerPrint_Clicker2_18F87J50\" -SP"
C:\_MikroC\_MesProjets_MikroC\common\" -SP"
C:\_MikroC\_MesProjets_MikroC\_LIB_LCD_I2C\" -SP"
C:\_MikroC\_MesProjets_MikroC\_16F1847_1827\" -SP"
C:\_MikroC\_MesProjets_MikroC\_12F1840_2xDS18B20_UART_Sleep\" -IP"
C:\_MikroC\_MesProjets_MikroC\_16F1847_OWS_DS18B20\" "_16F1847_OWS_2xDS18B20_Temper_170326.c" "
__Lib_Math.mcl" "
__Lib_MathDouble.mcl" "
__Lib_System.mcl" "
__Lib_Delays.mcl" "
__Lib_CType.mcl" "
__Lib_CString.mcl" "
__Lib_CStdlib.mcl" "
__Lib_CMath.mcl" "
__Lib_Conversions.mcl" "
__Lib_OneWire.mcl" "
__Lib_ADC.mcl" "
__Lib_EEPROM.mcl" "
__Lib_I2C_b14b25.mcl" "
__Lib_UART_b21.mcl"
0 1139 Available RAM: 1008 [bytes], Available ROM: 8192 [bytes]
0 122 Compilation Started P16F1847.c
1400 123 Compiled Successfully P16F1847.c
0 122 Compilation Started
__Lib_Delays.c
123 123 Compiled Successfully
__Lib_Delays.c
0 122 Compilation Started delays.h
0 1004 interrupt handler (Interrupts at 0x0004) _16F1847_OWS_2xDS18B20_Temper_170326.c
240 1163 Variable 'i' has been declared, but not used _16F1847_OWS_2xDS18B20_Temper_170326.c
283 1163 Variable 'i' has been declared, but not used _16F1847_OWS_2xDS18B20_Temper_170326.c
501 1163 Variable 'adpt' has been declared, but not used _16F1847_OWS_2xDS18B20_Temper_170326.c
572 1509 Generated baud rate is 19231 bps (error = 0.16 percent) _16F1847_OWS_2xDS18B20_Temper_170326.c
730 123 Compiled Successfully _16F1847_OWS_2xDS18B20_Temper_170326.c
0 127 All files Compiled in 109 ms
0 1144 Used RAM (bytes): 320 (32%)  Free RAM (bytes): 688 (68%) Used RAM (bytes): 320 (32%)  Free RAM (bytes): 688 (68%)
0 1144 Used ROM (program words): 2432 (30%)  Free ROM (program words): 5760 (70%) Used ROM (program words): 2432 (30%)  Free ROM (program words): 5760 (70%)
0 125 Project Linked Successfully 16F1847_OWS_2x18B20_temper_2017.mcppi
0 128 Linked in 47 ms
0 129 Project '16F1847_OWS_2x18B20_temper_2017.mcppi' completed: 313 ms
0 103 Finished successfully: 25 mars 2017, 18:52:02 16F1847_OWS_2x18B20_temper_2017.mcppi


*/